//-----------------------------------------------------------------------------
//
// Copyright(C) 2012 David Hill
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
//
//-----------------------------------------------------------------------------
//
// Heretic spawn number definitions.
//
// Identifiers beginning with T_ followed by a capital letter are reserved for
// use by this header.
//
//-----------------------------------------------------------------------------

#ifndef __HEADER__T_HERETIC_H__
#define __HEADER__T_HERETIC_H__


//----------------------------------------------------------------------------|
// Macros                                                                     |
//

#define T_NONE                   0
#define T_CLINK                  1
#define T_MUMMYLEADER            2
#define T_BEAST                  3
#define T_MUMMY                  4
#define T_IMP                    5
#define T_KNIGHT                 6
#define T_IMPLEADER              7
#define T_MUMMYGHOST             8
#define T_MUMMYLEADERGHOST       9
#define T_IMPFIREBALL           10
#define T_WIMPYWANDAMMO         11
#define T_HEFTYWANDAMMO         12

#define T_ITEMEGG               14
#define T_ITEMFLIGHT            15

#define T_ITEMTELEPORT          18
#define T_WIZARD                19
#define T_IRONLICH              20
#define T_BRIDGE                21

#define T_ITEMHEALTHPOTION      23
#define T_ITEMHEALTHFLASH       24
#define T_ITEMHEALTHFLASK       24 // ZDoom alternate name.
#define T_ITEMHEALTHFULL        25

#define T_CROSSBOW              27
#define T_BLASTER               28
#define T_PHOENIXROD            29
#define T_SKULLROD              30
#define T_MACE                  31
#define T_GAUNTLETS             32
#define T_WIMPYCROSSBOWAMMO     33
#define T_HEFTYCROSSBOWAMMO     34
#define T_WIMPYMACEAMMO         35
#define T_HEFTYMACEAMMO         36
#define T_WIMPYBLASTERAMMO      37
#define T_HEFTYBLASTERAMMO      38

#define T_MORPHBLAST            40
#define T_ROCK1                 41
#define T_ROCK2                 42
#define T_ROCK3                 43
#define T_DIRT1                 44
#define T_DIRT2                 45
#define T_DIRT3                 46
#define T_DIRT4                 47
#define T_DIRT5                 48
#define T_DIRT6                 49

#define T_STAINEDGLASS1         54
#define T_STAINEDGLASS2         55
#define T_STAINEDGLASS3         56
#define T_STAINEDGLASS4         57
#define T_STAINEDGLASS5         58
#define T_STAINEDGLASS6         59
#define T_STAINEDGLASS7         60
#define T_STAINEDGLASS8         61
#define T_STAINEDGLASS9         62
#define T_STAINEDGLASS0         63

#define T_SHIELD1               68
#define T_SHIELD2               69

#define T_ITEMTIMEBOMB          72
#define T_ITEMTORCH             73

#define T_BLUEKEY               85
#define T_GREENKEY              86
#define T_YELLOWKEY             87

#define T_SOUND_WIND           110
#define T_SOUND_WATERFALL      111

#define T_BEASTBALL            120
#define T_FEATHER              121
#define T_CHICKEN              122
#define T_VOLCANOBALL          123
#define T_TINYVOLCANOBALL      124
#define T_POD                  125
#define T_PODGENERATOR         126
#define T_KNIGHTAXE            127
#define T_KNIGHTBLOODAXE       128
#define T_KNIGHTGHOST          129

#define T_MUMMYHEAD            131
#define T_SNAKE                132
#define T_ITEMINVULNERABILITY  133
#define T_ITEMTOME             134
#define T_ITEMINVISIBILITY     135
#define T_ITEMBAGOFHOLDING     136
#define T_ITEMALLMAP           137
#define T_SNAKEPROJECTILE      138
#define T_SNAKEPROJECTILEBIG   139
#define T_WIZARDSHOT           140
#define T_DSPARILTELEPORTDEST  141
#define T_DSPARILONSERPENT     142
#define T_DSPARILALONE         143
#define T_SERPENTFIREBALL      144
#define T_DSPARILBLUESHOT      145
#define T_DSPARILWIZARDSPAWNER 146
#define T_CROSSBOWMAINBLAST    147
#define T_CROSSBOWMINIBLAST    148
#define T_CROSSBOWPOWERBLAST   149
#define T_VOLCANO              150
#define T_POWERWANDMINIBLAST   151
#define T_POWERWANDBIGGERBLAST 152
#define T_DEATHBALL            153
#define T_NOGRAVITYMACEBALL    154
#define T_BOUNCYMACEBALL       155
#define T_HEAVYMACEBALL        156
#define T_RIPPER               157
#define T_WIMPYSKULLRODAMMO    158
#define T_HEFTYSKULLRODAMMO    159
#define T_SKULLRODBLAST        160
#define T_WIMPYPHOENIXRODAMMO  161
#define T_HEFTYPHOENIXRODAMMO  162
#define T_PHOENIXSHOT          163
#define T_IRONLICHBLUESHOT     164
#define T_WHIRLWIND            165
#define T_REDTELEGLITTER       166
#define T_BLUETELEGLITTER      167

#endif//__HEADER__T_HERETIC_H__

